package instance;

import instance.FixedMatch.Added;

import java.util.*;


public class TempSol {
	Set<FixedMatch> matches;
	int k;
	
	public TempSol(){
		k=0;		
		this.matches = new HashSet<FixedMatch>();
	}
	
/*	public void addFix(Marker m1, Marker m2){		
		this.matches.add(new FixedMatch(m1, m2));
	}
	
	public void addFix(FixedMatch fm){		
		this.matches.add(fm);
	}
	*/
	public void addFix(Marker m1, Marker m2, boolean incrementBlockCount){		
		if (incrementBlockCount) k++;
		this.matches.add(new FixedMatch(m1, m2));
	}
	
	public void addFix(Marker m1, Marker m2, boolean incrementBlockCount, Added where){		
		if (incrementBlockCount) k++;
		this.matches.add(new FixedMatch(m1, m2, where));
	}
	
	public void addFix(FixedMatch fm, boolean incrementBlockCount){		
		if (incrementBlockCount) k++;
		this.matches.add(fm);
	}
	
	public TempSol copyTempSol(){
		TempSol newTemp = new TempSol();
		for (FixedMatch fm : matches) {
			newTemp.addFix(fm, false);
		}
		newTemp.k=k;
		return newTemp;
	}
	
	public int fixNumber(){
		return this.matches.size();
	}
	
	public void print(){
		for (FixedMatch fm: matches){
			System.out.println(fm.m1.tag()+"--"+fm.m2.tag()+" "+fm.where);
		}
	}
	
	public void checkIsComplete(Instance inst) throws Exception {
		
		/*
		 *  To be tested.
		 *  Remark: k can be bigger than the actual number of blocks, that's fine.
		 * 
		 */ 
		final int unmatched=-2;
		int n1= inst.getGenome1().size();
		int n2= inst.getGenome2().size();
		int[] matchedTo1= new int[n1];
		boolean[] matched2= new boolean[n2];
		
		//init
		for (int i=0;i<n1; i++) {
			matchedTo1[i]=unmatched;
		}		
		for (int i=0;i<n2; i++) {
			matched2[i]=false;
		}		
		// check all matches
		for (FixedMatch fm: matches) {
			Marker mark1=inst.genome1.getMarkerById(fm.m1.getId());
			Marker mark2=inst.genome2.getMarkerById(fm.m2.getId());
			if (mark1==null ||mark2==null) {
				mark1=inst.genome1.getMarkerById(fm.m2.getId());
				mark2=inst.genome2.getMarkerById(fm.m1.getId());
			}	
			if (mark1==null ||mark2==null) 
					throw new Exception("matched markers from the same genome or problem with Ids, fm : "+fm.toString());
			int pos1=inst.genome1.getMarkerIndex(mark1);
			int pos2=inst.genome2.getMarkerIndex(mark2);
			
			if (matchedTo1[pos1]!= unmatched)  throw new Exception("double match in 1 at pos"+pos1); 
			if (matched2[pos2]) throw new Exception("double match in 2 at pos "+pos2); 
            matchedTo1[pos1]=pos2;
            matched2[pos2]=true;
		}
		int prec=unmatched;
		int computedK=0;
		for (int i=0;i<n1; i++) {  //signed case: change this loop
			int curr=matchedTo1[i];
		    // compute CSP size: count non deleted markers which are not parallel to prec
			if (curr!= unmatched && curr!=prec+1) 				
				computedK++;   
			//rare markers in genome 1
			if (curr==unmatched && inst.getGenome1().getMarker(i).isRare())
				throw new Exception("unmatched rare marker in genome 1, pos="+i);
			prec=curr;
		}
		//rare markers in genome 2
		for (int i=0;i<n2; i++) {
			if (!matched2[i] && inst.getGenome2().getMarker(i).isRare())
				throw new Exception("unmatched rare marker in genome 2, pos="+i);
		}				
		
		if (computedK> k) throw new Exception("wrong number of blocks");
		/**/	
		
	}

	public void incrementBlockCount() {
		k++;		
	}
	
	
}
